#if defined vertex

out vec2 coord;

void main(){
  coord = gl_Vertex.xy;
  gl_Position = vec4(gl_Vertex.xy * 2.0 - 1.0, 0.0, 1.0);
}
#elif defined fragment
/* DRAWBUFFERS:135 */
layout(location = 0) out vec4 color1;
layout(location = 1) out vec4 color3;
layout(location = 2) out vec4 color5;

const bool colortex5MipmapEnabled = true;

in vec2 coord;

float renderAverageExposure(){
  float lod = int(log2(min(viewWidth, viewHeight))) - 1;

  float currentLum = renderLuminance701(texture2DLod(colortex5, vec2(0.75), 10).rgb);
  float previous = texture2D(colortex5, vec2(0.75)).a;

  return mix(currentLum, previous, clamp(1.0 - frameTime, 0.0, 0.90));
}

#include "/program/camera/common/bloom.glsl"
#include "/program/camera/common/dof.glsl"

void main(){
  color1 = renderDOF();

  color3 = renderBloom();

  color5.rgb = texture2D(colortex5, coord).rgb;
  color5.a = renderAverageExposure();
}
#endif
