#if defined vertex

out vec2 coord;

void main(){
  coord = gl_Vertex.xy;
  gl_Position = vec4(gl_Vertex.xy * 2.0 - 1.0, 0.0, 1.0);
}
#elif defined fragment
/* DRAWBUFFERS:0 */
layout(location = 0) out vec3 color0;

const bool colortex1MipmapEnabled = true;

in vec2 coord;

#include "/program/camera/common/bloom.glsl"
#include "/program/camera/common/exposure.glsl"
#include "/program/camera/common/tonemap.glsl"
#include "/program/camera/common/lensFlare.glsl"
#include "/program/camera/common/heatwave.glsl"

void main(){
  vec2 uv = coord;

  #if !defined world0
  //renderNetherHeatWaves(uv);
  #endif

  float exposure = renderExposure(DecodeColor(texture2D(colortex5, uv).a));
  vec3 bloom = renderBloom(uv, exposure);

  color0 = DecodeColor(DecodeRGBE8(texture2D(colortex1, uv)));
  color0 += bloom;
  color0 += texture2D(colortex4, coord).a * bloom * 16.0 * clamp01(float(texture2D(depthtex2, coord).x <= texture2D(depthtex1, coord).x));
  color0 += renderLensFlare(coord);
  color0 *= exposure;
  color0 = renderTonemap(color0);
}
#endif
