const vec2 samples[28] = vec2[28](vec2(0.0, 0.0),
										              vec2(0.0, 0.4),

										              vec2(0.15, 0.37),
										              vec2(0.29, 0.29),

										              vec2(-0.37, 0.15),
										              vec2(0.4, 0.0),

									                vec2(0.37, -0.15),
										              vec2(0.29, -0.29),

										              vec2(-0.15, -0.37),
										              vec2(0.0, 0.4),

										              vec2(-0.15, 0.37),
										              vec2(-0.29, 0.29),

										              vec2(0.37, 0.15),
										              vec2(-0.4, 0.0),

										              vec2(-0.37, -0.15),
										              vec2(-0.29, 0.29),

										              vec2(0.15, -0.37),
										              vec2(0.15, 0.37),

										              vec2(-0.37, 0.15),
										              vec2(0.37, -0.15),

										              vec2(-0.15, -0.37),
										              vec2(-0.15, 0.37),

										              vec2(0.37, 0.15),
										              vec2(-0.37, -0.15),

										              vec2(0.29, 0.29),
										              vec2(0.4, 0.0),

										              vec2(0.29, -0.29),
										              vec2(0.0, -0.4));

vec4 renderDOF(){
  const int steps = 28;
  const float rSteps = 1.0 / steps;

  vec3 color = vec3(0.0);

	vec2 aspecCorret = vec2(1.0, aspectRatio) * 1.5;

  const float maxBlur = 0.75;
  const float mipmapping	= 3.0;

  const float focal = (35.0 / FOCAL) * 0.04;
  const float aperture = (FOCAL / APERTURE) * 0.9;

  vec2 depth = vec2(texture2D(depthtex1, coord).x, texture2D(depthtex2, coord).x);
  float linearDepth = linearDepth(depth.x) * far;

  float focus = depth.y - centerDepthSmooth;
  float factor = focus * DOF_STRENGTH * 7.0 * focal;
        factor = clamp(factor * aperture, -maxBlur, maxBlur);

  #ifdef DOF
  for(int i = 0; i < steps; i++){
    vec2 sampleOffset = coord + samples[i] * aspecCorret * factor * 0.01;
    float sampleLod = mipmapping * abs(factor);

    color += texture2DLod(colortex5, sampleOffset + (jitter * 0.5), sampleLod).rgb;
  }

  return EncodeRGBE8(max0(color * rSteps));
  #else
  return EncodeRGBE8(max0(texture2D(colortex5, coord + (jitter * 0.5)).rgb));
  #endif
}
