vec3 wavingGround(vec3 viewPos, bool tall){
  bool topVertex = coord.y < mc_midTexCoord.y;
  bool topBlock  = mc_Entity.x == 1005;

  float doubleTall = 1.0;

  if (tall){
       doubleTall *= mix(float(topVertex) * 0.5, float(topVertex) * 0.5 + 0.5, float(topBlock));
  } else {
       doubleTall *= float(topVertex);
  }

  float t = TIME * 0.95;

  float magnitude = sin((t * 2.0) + viewPos.x + viewPos.z) * 0.06 + 0.06;

  float d0 = sin(t * 0.515015189115) * 3.0 - 2.0 + viewPos.z;
	float d1 = sin(t * 0.413367454418) * 3.0 - 2.0 + viewPos.x;
	float d2 = sin(t * 0.515015189115) * 3.0 - 2.0 + viewPos.x;
	float d3 = sin(t * 0.413367454418) * 3.0 - 2.0 + viewPos.z;

  vec3 wind = vec3(0.0);

  wind.x += sin((t * 1.24399475256) + (viewPos.x + d0) * 0.1 + (viewPos.z + d1) * 0.1 + viewPos.y) * magnitude;
	wind.z += sin((t * 0.24399475256) + (viewPos.z + d2) * 0.1 + (viewPos.y + d3) + viewPos.y) * magnitude;

  wind *= lmcoord.y;

  return wind * doubleTall;
}

vec3 wavingFire(vec3 viewPos){

  float t = TIME * 2.2;

  float magnitude = sin((t * 2.0) + viewPos.x + viewPos.z) * 1.5 + 1.5;

  float d0 = sin(t * 0.515015189115) * 3.0 - 2.0 + viewPos.z;
	float d1 = sin(t * 0.413367454418) * 3.0 - 2.0 + viewPos.x;
	float d2 = sin(t * 0.515015189115) * 3.0 - 2.0 + viewPos.x;
	float d3 = sin(t * 0.413367454418) * 3.0 - 2.0 + viewPos.z;

  vec3 wind = vec3(0.0);

  wind.x += sin((t * 0.24399475256) + (viewPos.x + d0) * 0.1 + (viewPos.z + d1) * 0.1 + viewPos.y) * (magnitude * 0.09 + 0.09);
	wind.z += sin((t * 0.24399475256) + (viewPos.z + d2) * 0.1 + (viewPos.x + d3) * 0.1 + viewPos.y) * (magnitude * 0.09 + 0.09);

  wind.x += sin((t * 1.24399475256) + (viewPos.x + d0) * 0.1 + (viewPos.z + d1) * 0.1 + viewPos.y) * (magnitude * 0.06 + 0.06);
	wind.z += sin((t * 1.24399475256) + (viewPos.y + d2) * 0.1 + (viewPos.x + d3) * 0.1 + viewPos.y) * (magnitude * 0.06 + 0.06);
  wind.y += sin((t * 0.24399475256) + (viewPos.z + d2) * 0.1 + (viewPos.x + d3) * 0.1 + viewPos.y) * 0.2 + 0.2;

  return wind * float(coord.y < mc_midTexCoord.y);
}

vec3 wavingLeaves(vec3 viewPos){
  float t = TIME;

  float magnitude = sin((t * 2.0) + viewPos.x + viewPos.z) * 0.02 + 0.02;

  float d0 = sin(t * 0.367867992224) * 3.0 - 2.0;
  float d1 = sin(t * 0.295262467443) * 3.0 - 2.0;
  float d2 = sin(t * 0.233749453392) * 3.0 - 2.0;
  float d3 = sin(t * 0.316055598953) * 3.0 - 2.0;

	vec3 wind = vec3(0.0);

  wind.x += sin((t * 1.80499344071) + (viewPos.x + d0) * 0.5 + (viewPos.z + d1) * 0.5 + viewPos.y) * magnitude;
	wind.z += sin((t * 1.49332750285) + (viewPos.y + d2) * 0.5 + (viewPos.x + d3) * 0.5 + viewPos.y) * magnitude;
	wind.y += sin((t * 0.48798950513) + (viewPos.z + d2) * 0.5 + (viewPos.x + d3) * 0.5 + viewPos.y) * magnitude * 0.4;

  wind *= lmcoord.y;

  return wind;
}

vec3 renderVertexDisplacement(vec3 position){
  position += cameraPosition;

  vec3 displacement = position;

  #ifdef WAVING_TERRAIN
  switch(int(mc_Entity.x)) {
	case 1010: displacement += wavingFire(position); break;
	case 2002:
	case 4002:
    case 1001: displacement += wavingGround(position, false); break;
    case 1004:
    case 1005: displacement += wavingGround(position, true); break;
    case 2001:
	case 3001:
	case 4001:
    case 1002: displacement += wavingLeaves(position); break;
  }
  #endif

  return displacement - cameraPosition;
}
