#if defined vertex
out vec2 coord;

out vec4 color;

#include "/program/gbuffers/common/curve.vsh"

void main(){
  coord = gl_MultiTexCoord0.xy;

  vec3 position = transMAD(gl_ModelViewMatrix, gl_Vertex.xyz);
  vec3 worldPosition = renderEarthCurvature(transMAD(gbufferModelViewInverse, position));
       position = transMAD(gbufferModelView, worldPosition);

  color = gl_Color;

  gl_Position = position.xyzz * diagonal4(gl_ProjectionMatrix) + gl_ProjectionMatrix[3];
  gl_Position.xy += jitter * gl_Position.w;
}
#elif defined fragment
/* DRAWBUFFERS:02 */
layout(location = 0) out vec4 color0;
layout(location = 1) out vec4 color2;

in vec2 coord;

in vec4 color;

vec4 data0 = texture2D(texture, coord);

void renderAlbedo(inout vec4 color0){
  vec4 albedo = data0 * color;

  #if TEXTURES == 1
  albedo = vec4(vec3(1.0), albedo.a);
  #endif

  color0 = albedo;
}

void main(){
  renderAlbedo(color0);

  color2 = vec4(EncodeNormal(vec3(0.0)), EncodeVec2(0.0, 0.0), EncodeVec2(1.0, 0.0), EncodeVec2(1.0, 1.0));
}
#endif
