#if defined vertex

out vec2 coord;

out vec3 position;
out vec3 worldPosition;

out vec4 color;

#include "/program/gbuffers/common/curve.vsh"

void main(){
  coord = gl_MultiTexCoord0.xy;

  position = transMAD(gl_ModelViewMatrix, gl_Vertex.xyz);
  worldPosition = renderEarthCurvature(transMAD(gbufferModelViewInverse, position));
  position = transMAD(gbufferModelView, worldPosition);

  color = gl_Color;

  gl_Position = position.xyzz * diagonal4(gl_ProjectionMatrix) + gl_ProjectionMatrix[3];
}
#elif defined fragment
/* DRAWBUFFERS:4 */
layout(location = 0) out vec4 color4;

in vec2 coord;

in vec4 color;

void main(){
  vec4 albedo = texture2D(texture, coord) * color;
  color4 = vec4(texture2D(colortex4, coord).rgb, albedo.a * wetness);
}
#endif
