float renderAmbientOcclusion(vec3 position, vec3 normal, float dither){
  #ifndef AO
  return 1.0;
  #endif

  const int steps = AO_QUALITY;
  const float rSteps = 1.0 / steps;

  #ifdef TEMPORAL_AA
  dither += fract(frameTimeCounter / 16.0 + dither);
  #endif

  float FOV = degrees(atan(1.0 / gbufferProjection[1].y) * 4.0);

	float ao = 0.0;

  float radius = 1.5;
  float power = 20.0;
  float strength = 10.0;

  for(int i = 0; i < steps; i++){
    float dx = radius / position.z * 90.0 / FOV;

    vec2 sampleOffset = coord + circlemap((dither + float(i)) * rSteps, 4096.0 * float(steps)) * (1.0 / 1.1) * dx;

    vec3 samplePosition = renderViewPosition(sampleOffset, texture2D(depthtex1, sampleOffset).x);
    float sampleVector = length(samplePosition - position);

    ao += clamp01(dot(normal, samplePosition - position) / sampleVector - 0.1) * clamp01(-(sampleVector - radius));
  }

  return pow(1.0 - clamp01(ao * rSteps), strength);
}
