const float sky_mieg = 0.75;

const float airNumberDensity = 2.5035422e6;
const float ozoneConcentrationPeak = 8e-6;
const float ozoneNumberDensity = airNumberDensity * exp2(-35e3 / 8e3) * ozoneConcentrationPeak;

const float earthSize = 6731e3;
const float sunRadius = 0.133333;
const float moonRadius = 0.516667;

const float atmosphereHeight = 110e3;
const vec2 scaleHeight = vec2(8.0e3, 1.2e3);

const vec3 ozoneCrossSection = vec3(3.51103766177301E-21, 8.2854797958699E-21, 0.96774621921165E-22) * 0.0001;
const vec3 rayleighCoeff = vec3(4.847e-6, 1.249e-5, 4.87e-5);
const vec3 mieCoeff = vec3(2e-6);
const vec3 ozoneCoeff = ozoneCrossSection * (ozoneNumberDensity * 2e-6);

const vec2 rScaleHeigh = 1.0 / scaleHeight;
const vec2 rScaledEarthSize = earthSize * rScaleHeigh;

float atmosphereRadius = earthSize + atmosphereHeight;
float atmosphereRadiusSquared = pow2(atmosphereRadius);

const mat2x3 scatteringCoeff = mat2x3(rayleighCoeff, mieCoeff);
const mat3 attenuationCoeff = mat3(rayleighCoeff, mieCoeff * 1.11, ozoneCoeff);

const vec3 sunLux = vec3(0.825, 0.875, 0.925) * 175e3 * SUNLIGHT_BRIGHTNESS;
const vec3 moonLux = vec3(0.875, 0.925, 0.995) * 0.35 * MOONLIGHT_BRIGHTNESS;

const float altitude = VOLUME_CLOUDS_HEIGHT;
const float thickness = VOLUME_CLOUDS_THICKNESS;
const float scale = 500.0 / thickness;
const float density = 0.30;

const float cloudMinHeight = altitude;
const float cloudMaxHeight = thickness + altitude;
