float renderSun(vec3 vector, vec3 sunVector) {
  float VdotS = dot(vector, sunVector);

  const float cosSunRadius = cos(radians(sunRadius));

  float sunLuminance = 1.0 / ((1.0 - cosSunRadius) * PI);

  return fstep(cosSunRadius, VdotS) * sunLuminance;
}

float renderMoon(vec3 vector, vec3 moonVector) {
  float VdotS = dot(vector, moonVector);

  const float cosMoonRadius = cos(radians(moonRadius));

  float moonLuminance = 1.0 / ((1.0 - cosMoonRadius) * PI);

  return fstep(cosMoonRadius, VdotS) * moonLuminance;
}

float renderStars(vec3 position, vec3 direction){
  position = position * renderRotMat(vec3(0.0, 1.0, 0.0), direction);

  const float res = 2048.0;

  vec3 rp = position * (0.15 * res);

	vec3 id = floor(rp);
  vec3 q = id - rp + 0.5;
  vec3 rn = hash33(id);

  float c  = 1.0 - smoothstep(0.2, 0.5, length(q));
    	  c *= step(rn.x, 0.1 * 0.1);

  return c * 0.5;
}
