vec3 renderSpecularPosition(vec3 worldPosition, vec3 worldVector, vec3 p, float dither, out bool hit){
  const int refinements = 8;
  const int steps = 16;
  const float rSteps = 1.0 / steps;

  vec3 increment =  worldVector * rSteps;
  vec3 position = increment * dither + worldVector;

  float os = 0.0;

  for(int i = 0; i < steps; ++i, position += increment){
    hit = true;

    float rayLength = length(position);

    renderShape(position, os);

    if(renderRayHit(os, rayLength)) break;

    hit = false;
  }
  if(!hit) return position;

  increment = -increment / refinements;
  position = increment * dither + position;

  for(int j = 0; j < steps; ++j, position += increment){
    float rayLength = length(position);

    renderShape(position, os);

    if(renderRayHitInverse(os, rayLength)) break;
  }

  return position;
}
